--[[

Version 2.0 - Initial release of WotLK Branch to WowAce SVN

New Author : Levva of EU Khadgar - by kind Permission of Disquette

Renamed to ShockAndAwe (based on orginal DisqoDice by Disquette)

Completely overhauled for WotLK.
 - Updated to use Ace3
 - Removed totem twisting as not available in WotLK
 - Added bar for Maelstrom Weapon stacks
 - revamped bar timings so that talents taken into account
    - now uses Imp.SS talent to reduce SS cooldown
    - still manual config of 4 piece Arena bonus (on TODO list to automate this)
    - uses Maelstrom talents to determine whether to show maelstrom bar
    - now honors talents in Reverberation to adjust cooldown timer on Shock bar
    - added initial start at config window on blizzard config panel (well it has an about so far!!)

Version 2.01 -
	Enabled the /dqd & /disqodice config options 
	Added confirmation text when an option was used
	
Version 2.02 -
	Fixed display and moving bars options not showing frames after moved
	Fixed turning maelstrom on and off not comming back on
	
Version 2.10 - 
	Decided to change addon name to ShockAndAwe
	Added drycoded support for Lava Burst timer bar
	Refreshed WS code to be Shield code - added text support for Shields
	Added text support for Wind Shock
	Added check for Shamanistic Focus up
	Fixed respeccing issue
	Changed Maelstrom to show 15 sec cooldown - now hidden out of combat, pale in combat and lights up with 5 charges.
	Added text indicator on Maelstrom bar to show how many stacks
	Added text on shield indicator to show how many orbs
	Added icon to shock bar to show if Shamanistic Focus buff present - not working
	Fixed typo preventing SavedVariables actually saving between sessions
	Added text on shock bar to show if Shamanistic Focus has procced
	Altered bar height so that if you choose to show less bars then the spacing changes - eliminates gaps for non shown bars
        - this may need code to check if spacing is still valid if user turns on or off showing a bar during session
	
Version 2.11
	Changed width of SS to be full frame width and adjusted Shock & WFProc to proportional widths
	Fixed issue of maelstrom bar not showing after having moved frame
	
Version 2.12
	Added config tab for Uptime 
	Radical overhaul of the shield frame so that it consistently updates after zoning/reloading etc.
	
Version 2.13 
	Added version info
	Added Uptime Frame 
	Changed display to moveframes and updated background when in moving mode to make it more obvious
	Uptime Frames now show initial attempt at uptimes of various buffs - lots of testing still required
		- session time bars displaying 
		- last fight ones go wrong after second fight though - TODO
		- no icons displaying - TODO
		
Version 2.14 
	Fixed icon files for uptime frames and Shamanistic Focus
	Fixed last fight uptimes showing >100%
	Added tooptip to uptime frame
	
Version 2.15
	added startup to disable addon if not a shaman
	
Version 2.20 
	Removed Shamanistic Focus icon as build 8926 has it as passive ability 
	Added earth shock/flame shock rotation display icon
	Added wind shock threat threshold warning - tested with help from Isbeorn on Coldarra beta server
	Fixed issue with lastfight buff times being summed incorrectly (was a cut n paste error)
	Lots and lots of tweaking of config options for bars - still needs idiot proof testing though
	TODO - Reset option - make sure it resets all bar values
	
Version 2.21 
	Fixed debug info for windshock spamming chat when in a party
	Added config option to disable showing of uptime frame
	Added config option to disable showing text on bars
	Fixed Maelstrom weapon & Imp SS talents which had moved in build 8970
	
Version 2.22
	Localised more strings
	
Version 2.30
	Added Lava Lash CD bar
	Added Lava Burst CD bar
	Changed check for Flame Shock on target to check that its mine
	Added AceGUI-3.0 dependency
	
Version 2.40
	Fixed Wind Shock colour to dark gray similar to WS icon
	Added icon on Maelstrom Weapon bar to show LB or LvB depending on cooldowns etc.
	Added temp fix for Maelstrom Talents not being seen on login
	
Version 2.41
	Upped Windshock alpha so its easier to see
	
Version 2.50 
	Added support for SharedMedia
	
Version 2.51
	Fixed Lava Lash not showing bug
	
Version 2.52 
	Updated MW cooldown time to 30 sec as per build 9014
	Fixed bug if bar was not showing on load it would display in wrong place when activated during game
	
Version 2.60 
	Added Options to pick your own colour scheme for all the bars
	
Version 2.61
	Removed Lava Burst icon display from 5 stack of MW
	
Version 2.62
	Finally worked out syntax to have project work on new Curseforge.com SVN so revision now uses CF revision numbers
	this also means I can simply tag a version as release and it automatically appears on Curse.com website.
	
Version 2.63 
	Swapped order of Shock and Lava Lash bar so order is Shield, MW, SS, Shock, LL - which pretty much matches priority queue
	Added option to hide shield bar if its active - so that you only see it if it needs refreshing.
	
Version 2.64
	Added no-lib stripping and optionaldeps

Version 2.70 
	Added option to set border textures
	Moved various options around and re-ordered the menus
	Massive overhaul of the Uptime frame - fixed a couple of memory leaks - should run a lot faster and a lot less memory
	
--]]

if select(2, UnitClass('player')) ~= "SHAMAN" then
	DisableAddOn("ShockAndAwe")
	return
end

local L = LibStub("AceLocale-3.0"):GetLocale("ShockAndAwe")
local AceAddon = LibStub("AceAddon-3.0")
local media = LibStub:GetLibrary("LibSharedMedia-3.0");
ShockAndAwe = AceAddon:NewAddon("ShockAndAwe","AceConsole-3.0", "AceEvent-3.0", "AceTimer-3.0")

local REVISION = tonumber(("$Revision: 12 $"):match("%d+"))

local ShockAndAweBaseFrame = CreateFrame("Frame","ShockAndAweBase",UIParent)
local maelstromFrame = CreateFrame("Frame","ShockAndAweBar1Status",ShockAndAweBaseFrame) 
local mwIconFrame = CreateFrame("Frame","ShockAndAweBar1StatusIcon",ShockAndAweBaseFrame)
local SSFrame = CreateFrame("Frame","ShockAndAweBar2Status",ShockAndAweBaseFrame)
local shockFrame = CreateFrame("Frame","ShockAndAweBar3Status",ShockAndAweBaseFrame)
local shockIconFrame = CreateFrame("Frame","ShockAndAweBar3StatusIcon",ShockAndAweBaseFrame)
local windfuryFrame = CreateFrame("Frame","ShockAndAweBar4Status",ShockAndAweBaseFrame)
local shieldFrame = CreateFrame("Frame","ShockAndAweBar5Status",ShockAndAweBaseFrame)
local LvBFrame = CreateFrame("Frame","ShockAndAweBar6Status",ShockAndAweBaseFrame)
local LavaLashFrame = CreateFrame("Frame","ShockAndAweBar7Status",ShockAndAweBaseFrame)
local gcdFrame = CreateFrame("Frame", "ShockAndAweBar8Status", ShockAndAweBaseFrame)
local SAAUptimeFrame = CreateFrame("Frame", "ShockAndAweUptime", UIParent)
	
local StatsFrame = CreateFrame("Frame", "StatsFrame", UIParent)

local textures = {}
local borders = {}
local fonts = {}
local barBackdrop = {
		bgFile = "Interface/Tooltips/UI-Tooltip-Background",
		edgeFile = "Interface/Tooltips/UI-Tooltip-Border",
		tile = false, tileSize = 0, edgeSize = 12,
		insets = { left = 2, right = 2, top = 2, bottom = 2 }
	}
local frameBackdrop ={
		bgFile = "Interface/Tooltips/UI-Tooltip-Background",
		--edgeFile = "Interface/Tooltips/UI-Tooltip-Border",
		tile = false, tileSize = 0, edgeSize = 12,
		insets = { left = 0, right = 0, top = 0, bottom = 0 }
	}
local SSmin, SSmax, ShockMin, ShockMax, WFPMin, WFPMax, ShieldMin, ShieldMax, MaelstromMin, MaelstromMax, LvBMin, LvBMax, LLMin, LLMax
local updateActiveSS = false
local updateActiveMaelstrom = false
local updateActiveLavaLash = false
local updateActiveLvB = false
local lvbOnCooldown = false
local updateActiveShock = false
local updateActiveShamanistic = false
local updateActiveWFProc = false
local updateActiveShield = false
local WFProcTime = 0
local SSTime = 0
local LLTime = 0
local LvBTime = 0
local ShockTime = 0
local ShieldTime = 0

local stormstrike_cast = L["Stormstrike"]
local earthshock_cast = L["Earth_Shock"]
local flameshock_cast = L["Flame_Shock"]
local frostshock_cast = L["Frost_Shock"]
local windshock_cast = L["Wind_Shock"]
local lavaburst_cast = L["Lava Burst"]
local lavalash_cast = L["Lava Lash"]
local WindfuryCombatLog = L["WF_Attack"]
local Maelstrom_Active = L["Maelstrom"]
local WaterShieldCast = L["WaterShield"]
local LightningShieldCast = L["LightningShield"]
local EarthShieldActive = L["EarthShield"]
local ElementalDevastation = L["ElementalDevastation"]
local Flurry = L["Flurry"]
local UnleashedRage = L["UnleashedRage"]
local playerName=UnitName("player");

-------------------
-- Config details
-------------------

local function getOptions()
	local options = { 
		name = "ShockAndAwe",
		handler = ShockAndAwe,
		type='group',
		childGroups ='tree',
		args = {
			frames = {
				name = L["Frame Options"],
				type = 'group',
				order = 1,
				args = {
					width = {
						type = 'range',
						name = L["Bar Width"],
						desc = L["help_width"],
						min = 100,
						max = 500,
						step = 10,
						get = "GetWidth",
						set = "SetWidth",
						order = 32,
					},
					scale = {
						type = 'range',
						name = L["Bar Scale"],
						desc = L["help_scale"],
						min = 0.25,
						max = 3.00,
						step = 0.05,
						get = "GetScale",
						set = "SetScale",
						order = 33,
					},
					reset = {
						type = 'execute',
						name = L["Reset"],
						desc = L["help_reset"],
						func = "ResetAll",
						order = 37,
					},
				},
			},
			bars = {
				name = L["TimerBars"],
				type = 'group',
				order = 2,
				args = {
					break1 = {
						type = 'header',
						name = L["Bars Section"],
						order = 1,
					},
					shieldbar = {
						type = 'toggle',
						name = L["Shield Bar"],
						desc = L["help_shield"],
						get = "shieldQuery",
						set = "ActivateShield",
						order = 2,
						},
					maelstrom = {
						type = 'toggle',
						name = L["Maelstrom Bar"],
						desc = L["help_maelstrom"],
						get = "maelstromQuery",
						set = "ActivateMaelstrom",
						order = 3,
						},
					SS = {
						type = 'toggle',
						name = L["Stormstrike Bar"],
						desc = L["help_ss"],
						get = "SSQuery",
						set = "ActivateSS",
						order = 4,
					},
					lavaburst = {
						type = 'toggle',
						name = L["Lava Burst"],
						desc = L["help_lavaburst"],
						get = "lavaburstQuery",
						set = "ActivateLavaBurst",
						order = 5,
					},
					shock = {
						type = 'toggle',
						name = L["Shock Bar"],
						desc = L["help_shock"],
						get = "shockQuery",
						set = "ActivateShock",
						order = 6,
					},
					lavalash = {
						type = 'toggle',
						name = L["Lava Lash"],
						desc = L["help_lavalash"],
						get = "lavalashQuery",
						set = "ActivateLavaLash",
						order = 7,
					},
					break2 = {
						type = 'header',
						name = L["Icons Section"],
						order = 20,
					},
					rotation = {
						type = 'toggle',
						name = L["Shock Rotation"],
						desc = L["help_rotation"],
						get = "rotationQuery",
						set = "ActivateRotation",
						order = 21,
					},
					windshock = {
						type = 'toggle',
						name = L["Wind Shock"],
						desc = L["help_windshock"],
						get = "windshockQuery",
						set = "ActivateWindShock",
						order = 22,
					},
					mwicon = {
						type = 'toggle',
						name = L["LvB or LL icon"],
						desc = L["help_mwicon"],
						get = "mwiconQuery",
						set = "ActivateMWicon",
						order = 23,
					},
					break4 = {
						type = 'header',
						name = L["Misc Options"],
						order = 40,
					},
					activeshield = {
						type = 'toggle',
						name = L["Show Active Shields"],
						desc = L["help_activeshields"],
						get = "activeShieldsQuery",
						set = "ActivateActiveShields",
						order = 41,
					},
					arena = {
						type = 'toggle',
						name = L["4 piece arena bonus"],
						desc = L["help_arena"],
						get = "arenaQuery",
						set = "ActivateArena",
						order = 42,
					},
					text = {
						type = 'toggle',
						name = L["Text Display"],
						desc = L["help_textonbars"],
						get = "textOnBarsQuery",
						set = "ActivateTextOnBars",
						order = 43,
					},
					threat = {
						type = 'range',
						name = L["Threat Threshold"],
						desc = L["help_threat"],
						min = 75,
						max = 110,
						step = 1,
						get = "GetThreatThreshold",
						set = "SetThreatThreshold",
						order = 44,
					},
				},
			},
			barcolours = {
				name = L["BarColours"],
				type = 'group',
				order = 3, 
				args = {
					break1 = {
						type = 'header',
						name = L["Shields"],
						order = 1,
					},
					watershield = {
						type = 'color',
						name = L["Water Shield Colour"],
						desc = L["colWaterShield"],
						get = "getWaterShieldColour",
						set = "setWaterShieldColour",
						hasAlpha = true,
						order = 2,
					},
					lightningshield = {
						type = 'color',
						name = L["Lightning Shield Colour"],
						desc = L["colLightningShield"],
						get = "getLightningShieldColour",
						set = "setLightningShieldColour",
						hasAlpha = true,
						order = 3,
					},
					earthshield = {
						type = 'color',
						name = L["Earth Shield Colour"],
						desc = L["colEarthShield"],
						get = "getEarthShieldColour",
						set = "setEarthShieldColour",
						hasAlpha = true,
						order = 4,
					},
					noshield = {
						type = 'color',
						name = L["Shield Down Colour"],
						desc = L["colNoShield"],
						get = "getNoShieldColour",
						set = "setNoShieldColour",
						hasAlpha = false,
						order = 5,
					},
					break2 = {
						type = 'header',
						name = L["Shocks"],
						order = 6,
					},
					flameshock = {
						type = 'color',
						name = L["Flame Shock Colour"],
						desc = L["colFlameShock"],
						get = "getFlameShockColour",
						set = "setFlameShockColour",
						hasAlpha = true,
						order = 7,
					},
					earthshock = {
						type = 'color',
						name = L["Earth Shock Colour"],
						desc = L["colEarthShock"],
						get = "getEarthShockColour",
						set = "setEarthShockColour",
						hasAlpha = true,
						order = 8,
					},
					frostshock = {
						type = 'color',
						name = L["Frost Shock Colour"],
						desc = L["colFrostShock"],
						get = "getFrostShockColour",
						set = "setFrostShockColour",
						hasAlpha = true,
						order = 9,
					},
					windshock = {
						type = 'color',
						name = L["Wind Shock Colour"],
						desc = L["colWindShock"],
						get = "getWindShockColour",
						set = "setWindShockColour",
						hasAlpha = true,
						order = 10,
					},
					break3 = {
						type = 'header',
						name = L["Maelstrom Bar"],
						order = 11,
					},
					maelstrom = {
						type = 'color',
						name = L["Maelstrom Bar Colour"],
						desc = L["colMaelstrom"],
						get = "getMaelstromColour",
						set = "setMaelstromColour",
						hasAlpha = false,
						order = 12,
					},
					msalpha = {
						type = 'range',
						name = L["Maelstrom Alpha"],
						desc = L["help_width"],
						min = 0,
						max = 1,
						isPercent = true,
						get = "GetMSalpha",
						set = "SetMSalpha",
						order = 13,
					},
					msalphaFull = {
						type = 'range',
						name = L["Maelstrom Full Alpha"],
						desc = L["help_width"],
						min = 0,
						max = 1,
						isPercent = true,
						get = "GetMSalphaFull",
						set = "SetMSalphaFull",
						order = 14,
					},
					break4 = {
						type = 'header',
						name = L["Other Bars"],
						order = 15,
					},
					stormstrike = {
						type = 'color',
						name = L["Stormstrike Bar Colour"],
						desc = L["colStormstrike"],
						get = "getStormstrikeColour",
						set = "setStormstrikeColour",
						hasAlpha = true,
						order = 16,
					},
					windfury = {
						type = 'color',
						name = L["Windfury Bar Colour"],
						desc = L["colWindfury"],
						get = "getWindfuryColour",
						set = "setWindfuryColour",
						hasAlpha = true,
						order = 17,
					},
					lavalash = {
						type = 'color',
						name = L["Lava Lash Bar Colour"],
						desc = L["colLavaLash"],
						get = "getLavaLashColour",
						set = "setLavaLashColour",
						hasAlpha = true,
						order = 18,
					},
					lavaburst = {
						type = 'color',
						name = L["Lava Burst Bar Colour"],
						desc = L["colLavaBurst"],
						get = "getLavaBurstColour",
						set = "setLavaBurstColour",
						hasAlpha = true,
						order = 19,
					},
				},
			},
			media = {
				name = L["Media Options"],
				type = 'group',
				order = 4, 
				args = {
					texture = {
						type = 'select',
						name = L["Bar Texture"],
						get = "GetBarTexture",
						set = "SetBarTexture",
						values = textures,
						order = 1,
					},
					border = {
						type = 'select',
						name = L["Border Texture"],
						get = "GetBorderTexture",
						set = "SetBorderTexture",
						values = borders,
						order = 2,
					},
					barborder = {
						type = 'select',
						name = L["Bar Border Texture"],
						get = "GetBarBorderTexture",
						set = "SetBarBorderTexture",
						values = borders,
						order = 3,
					},
					barfont = {
						type = 'select',
						name = L["Bar Font"],
						get = "GetBarFont",
						set = "SetBarFont",
						values = fonts,
						order = 4,
					},
					barfontsize = {
						type = 'range',
						name = L["Bar Font Size"],
						min = 6,
						max = 32,
						step = 1,
						get = "GetBarFontSize",
						set = "SetBarFontSize",
						order = 5,
					},
				},
			},
			uptime = {
				name = L["UptimeFrame"],
				type = 'group',
				order = 5,
				args = {
					show = {
						type = 'toggle',
						name = L["Show Frame"],
						desc = L["help_showuptime"],
						get = "showUptimeQuery",
						set = "ActivateShowUptime",
						order = 8,
					},
					resetpos = {
						type = 'execute',
						name = L["Reset Positions"],
						desc = L["help_reset"],
						func = "ResetAllUptime",
					},
					resetsession = {
						type = 'execute',
						name = L["Reset Session info"],
						desc = L["help_reset"],
						func = "InitialiseUptime",
					},			
				},			
			},
			testbar = {
				type = 'execute',
				name = L["Display Test Bar"],
				desc = L["help_testbar"],
				func = "WFProcBar",
				order = 1,
			},
			version = {
				type = 'execute',
				name = L["Version"],
				desc = L["help_version"],
				func = "DisplayVersion",
				order = 2,
			},
			moveframes = {
				type = 'toggle',
				name = L["Move Frames"],
				desc = L["help_display"],
				get = "BarShowQuery",
				set = "ShowHideBars",
				order = 3,
			},
			debug = {
				type = 'toggle',
				name = L["Debug mode"],
				desc = L["help_debug"],
				get = "debugQuery",
				set = "ActivateDebug",
				order = 4,
			},
		},
	}
	return options
end

local defaults = {
	char = {
		message = "Welcome Home!",
		barshow = true,
		relativeTo = "UIParent",
		relativePoint = "CENTER",
		point = "CENTER",
		texture = "Blizzard",
		barfont = "Friz Quadrata TT",
		barfontsize = 12,
		border = "None",
		barborder = "Blizzard Tooltip",
		xOffset = 0,
		yOffset = 0,
		fWidth = 300,
		fHeight = 175,
		resetOn = true,
		scale = 1,
		ShockPercent = .6,
		shockshow = true,
		rotationshow = true,
		windshockshow = true,
		threatThreshold = 90,
		ssshow = true,
		lvbshow = false,
		llshow = false,
		maelstromTalents = 0,
		lavaLashTalented = 0,
		mwicon = true,
		shieldshow = true,
		activeshields = true,
		msshow = true,
		msstacks = 0,
		arena = false,
		barstext = true,
		SSlen = 10,
		LLlen = 6,
		LvBlen = 8,
		ShockLen = 6,
		lastshock = "",
		debug = false,
		colours = {
			watershield = { r=.6, g=.6,	b=1, a=.3 },
			lightningshield = { r=0, g=0, b=1, a=.5 },
			earthshield = { r=0, g=1, b=0, a=.5 },
			noshield = { r=1, g=0, b=0, a=1 },
			
			flameshock = { r=1, g=.6, b=.2, a=.9 },
			earthshock = { r=0, g=1, b=.3, a=.9	},
			frostshock = { r=.6, g=.6, b=1, a=.9 },
			windshock = { r=.6, g=.6, b=.6, a=.9 },
			
			maelstrom = { r=1, g=.5, b=1, a=.3 },
			msalpha = .3,
			msalphaFull = .9,

			lavalash = { r=1, g=.1, b=.1, a=.9 },
			lavaburst = { r=.8, g=.6, b=.2, a=.9 },
			stormstrike = { r=1, g=1, b=.2, a=.9 },
			windfury = { r=1, g=0, b=0, a=.5 },
		},
		uptime = {
			show = true,
			fWidth = 120,
			fHeight = 160,
			barWidth = 100,
			barHeight = 20,
			relativeTo = "UIParent",
			relativePoint = "CENTER",
			point = "CENTER",
			xOffset = 0,
			yOffset = -125,
			alpha = 0.4,
			scale = 1,
			flurry = {
				colourRed = 1, 
				colourGreen = 0,
				colourBlue = 0,
				alpha = 0.5,
			},
			ed = {
				colourRed = 1, 
				colourGreen = 1,
				colourBlue = 0,
				alpha = 0.5,
			},
			ur = {
				colourRed = 0, 
				colourGreen = 0,
				colourBlue = 1,
				alpha = 0.5,
			},
		},
		stats = {
			show = true,
			fWidth = 120,
			fHeight = 160,
			barWidth = 100,
			barHeight = 20,
			relativeTo = "SAAUptimeFrame",
			relativePoint = "TOPLEFT",
			point = "TOPLEFT",
			xOffset = 125,
			yOffset = 0,
			alpha = 0.4,
			scale = 1,			
		},
	}
}

function ShockAndAwe:ActivateSS()
	self.db.char.ssshow = not self.db.char.ssshow
	self:CreateBaseFrame()
	if (self.db.char.ssshow) then
		self:Print(L["config_SS_on"])
	else
		self:Print(L["config_SS_off"])
	end
end

function ShockAndAwe:ActivateShock()
	self.db.char.shockshow = not self.db.char.shockshow
	self:CreateBaseFrame()
	if (self.db.char.shockshow) then
		self:Print(L["config_Shock_on"])
	else
		self:Print(L["config_Shock_off"])
	end
end

function ShockAndAwe:ActivateShield()
	self.db.char.shieldshow = not self.db.char.shieldshow
	self:CreateBaseFrame()
	if (self.db.char.shieldshow) then
		self:Print(L["config_Sheild_on"])
	else
		shieldFrame:Hide()
		self:Print(L["config_Sheild_off"])
	end
end

function ShockAndAwe:ActivateArena()
	self.db.char.arena = not self.db.char.arena
	self:SetTalentEffects()
	self:CreateBaseFrame()
	if (self.db.char.arena) then
		self:Print(L["config_Arena_on"])
	else
		self:Print(L["config_Arena_off"])
	end
end

function ShockAndAwe:ActivateActiveShields()
	self.db.char.activeshields = not self.db.char.activeshields
	self:UpdateShieldBar()
	if (self.db.char.activeshields) then
		self:Print(L["config_ActiveShields_on"])
	else
		self:Print(L["config_ActiveShields_off"])
	end
end

function ShockAndAwe:ActivateMWicon()
	self.db.char.mwicon = not self.db.char.mwicon
	if (self.db.char.mwicon) then
		self:Print(L["config_MWicon_on"])
	else
		self:Print(L["config_MWicon_off"])
	end
end

function ShockAndAwe:ActivateShowUptime()
	self.db.char.uptime.show = not self.db.char.uptime.show
	if (self.db.char.uptime.show) then
		SAAUptimeFrame:Show()
		self:Print(L["config_Uptime_on"])
	else
		SAAUptimeFrame:Hide()
		self:Print(L["config_Uptime_off"])
	end
end

function ShockAndAwe:ActivateMaelstrom()
	self.db.char.msshow = not self.db.char.msshow
	self:CreateBaseFrame()
	if (self.db.char.msshow) then
		self:MaelstromBar()
		self.db.char.msstacks = ShockAndAwe:GetMaelstromInfo()
		self:Print(L["config_MW_on"])
	else
		maelstromFrame:Hide()
		self:Print(L["config_MW_off"])
	end
end

function ShockAndAwe:ActivateLavaLash()
	self.db.char.llshow = not self.db.char.llshow
	self:CreateBaseFrame()
	if (self.db.char.llshow) then
		LavaLashFrame:Show()
		self:Print(L["config_LL_on"])
	else
		LavaLashFrame:Hide()
		self:Print(L["config_LL_off"])
	end
end

function ShockAndAwe:ActivateLavaBurst()
	self.db.char.lvbshow = not self.db.char.lvbshow
	self:CreateBaseFrame()
	if (self.db.char.lvbshow) then
		LvBFrame:Show()
		self:Print(L["config_LvB_on"])
	else
		LvBFrame:Hide()
		self:Print(L["config_LvB_off"])
	end
end

function ShockAndAwe:ActivateRotation()
	self.db.char.rotationshow = not self.db.char.rotationshow
	if (self.db.char.rotationshow) then
		self:Print(L["config_rotation_on"])
	else
		self:Print(L["config_rotation_off"])
	end
end

function ShockAndAwe:ActivateDebug()
	self.db.char.debug = not self.db.char.debug
	if (self.db.char.debug) then
		self:Print(L["config_debug_on"])
	else
		self:Print(L["config_debug_off"])
	end
end

function ShockAndAwe:ActivateWindShock()
	self.db.char.windshockshow = not self.db.char.windshockshow
	if (self.db.char.windshockshow) then
		self:Print(L["config_WSicon_on"])
	else
		self:Print(L["config_WSicon_off"])
	end
end

function ShockAndAwe:ActivateTextOnBars()
	self.db.char.barstext = not self.db.char.barstext
	self:UpdateShieldBar()
	if (self.db.char.barstext) then
		self:Print(L["config_Barstext_on"])
	else
		self:Print(L["config_Barstext_off"])
	end
end

function ShockAndAwe:ShowHideBars()
	self.db.char.barshow = not self.db.char.barshow
	if self.db.char.barshow then
		SAAUptimeFrame:EnableMouse(1)
		SAAUptimeFrame:SetBackdropColor(0, 0, 0, 1);
		ShockAndAweBaseFrame:EnableMouse(1);
		ShockAndAweBaseFrame:SetBackdropColor(0, 0, 0, 1);
		maelstromFrame:Show()
		SSFrame:Show()
		shockFrame:Show()
		windfuryFrame:Show()
		shieldFrame:Show()
		LavaLashFrame:Show()
		LvBFrame:Show()
	else
		ShockAndAweBaseFrame:EnableMouse(0);
		ShockAndAweBaseFrame:SetBackdropColor(1, 1, 1, 0);
		SAAUptimeFrame:EnableMouse(0)
		SAAUptimeFrame:SetBackdropColor(0, 0, 0, 0.3);
		-- ShockAndAweBaseFrame:Hide()
		maelstromFrame:Hide()
		SSFrame:Hide()
		shockFrame:Hide()
		windfuryFrame:Hide()
		LavaLashFrame:Hide()
		LvBFrame:Hide()
		self:UpdateShieldBar()
	end
end

function ShockAndAwe:FinishedMoving(uptime)
	local var, frame
	if uptime then 
		var = self.db.char.uptime
		frame = SAAUptimeFrame
	else
		var = self.db.char
		frame = ShockAndAweBaseFrame
	end
	local point, relativeTo, relativePoint, xOffset, yOffset = frame:GetPoint();
	var.point = point
	var.relativeTo = relativeTo
	var.relativePoint = relativePoint
	var.xOffset = xOffset
	var.yOffset = yOffset
end

function ShockAndAwe:BarShowQuery()
	return self.db.char.barshow
end

function ShockAndAwe:SSQuery()
	return self.db.char.ssshow
end

function ShockAndAwe:shockQuery()
	return self.db.char.shockshow
end

function ShockAndAwe:rotationQuery()
	return self.db.char.rotationshow
end

function ShockAndAwe:mwiconQuery()
	return self.db.char.mwicon
end

function ShockAndAwe:windshockQuery()
	return self.db.char.windshockshow
end

function ShockAndAwe:shieldQuery()
	return self.db.char.shieldshow
end

function ShockAndAwe:arenaQuery()
	return self.db.char.arena
end

function ShockAndAwe:activeShieldsQuery()
	return self.db.char.activeshields
end

function ShockAndAwe:showUptimeQuery()
	return self.db.char.uptime.show
end

function ShockAndAwe:maelstromQuery()
	return self.db.char.msshow
end

function ShockAndAwe:lavalashQuery()
	return self.db.char.llshow
end

function ShockAndAwe:lavaburstQuery()
	return self.db.char.lvbshow
end

function ShockAndAwe:textOnBarsQuery()
    return self.db.char.barstext
end

function ShockAndAwe:debugQuery()
	return self.db.char.debug
end

function ShockAndAwe:GetBarTexture()
    return self.db.char.texture
end

function ShockAndAwe:GetBorderTexture()
    return self.db.char.border
end

function ShockAndAwe:GetBarBorderTexture()
    return self.db.char.barborder
end

function ShockAndAwe:GetBarFont()
    return self.db.char.barfont
end

function ShockAndAwe:GetBarFontSize()
    return self.db.char.barfontsize
end

function ShockAndAwe:GetWidth()
    return self.db.char.fWidth
end

function ShockAndAwe:GetScale()
    return self.db.char.scale
end

function ShockAndAwe:GetMSalpha()
    return self.db.char.colours.msalpha
end

function ShockAndAwe:GetMSalphaFull()
    return self.db.char.colours.msalphaFull
end

function ShockAndAwe:GetThreatThreshold()
    return self.db.char.threatThreshold
end

function ShockAndAwe:SetBarFont(info, newValue)
	self.db.char.barfont = newValue
	self:RedrawFrames()
end

function ShockAndAwe:SetBarFontSize(info, newValue)
	self.db.char.barfontsize = newValue
	self:RedrawFrames()
end

function ShockAndAwe:SetBarTexture(info, newValue)
	self.db.char.texture = newValue
	shieldFrame.statusbar:SetStatusBarTexture(media:Fetch('statusbar', newValue))
	maelstromFrame.statusbar:SetStatusBarTexture(media:Fetch('statusbar', newValue))
	LvBFrame.statusbar:SetStatusBarTexture(media:Fetch('statusbar', newValue))
	LavaLashFrame.statusbar:SetStatusBarTexture(media:Fetch('statusbar', newValue))
	SSFrame.statusbar:SetStatusBarTexture(media:Fetch('statusbar', newValue))
	shockFrame.statusbar:SetStatusBarTexture(media:Fetch('statusbar', newValue))
	windfuryFrame.statusbar:SetStatusBarTexture(media:Fetch('statusbar', newValue))
end

function ShockAndAwe:SetBorderTexture(info, newValue)
	self.db.char.border = newValue
	local newTexture = media:Fetch("border", self.db.char.border)
	if newTexture then
		frameBackdrop.edgeFile = newTexture
		self:RedrawFrames()
	else
		if self.db.char.debug then
			self:Print("border texture not found. Trying to set "..self.db.char.border)
		end
	end
end

function ShockAndAwe:SetBarBorderTexture(info, newValue)
	self.db.char.barborder = newValue
	local newTexture = media:Fetch("border", self.db.char.barborder)
	if newTexture then
		barBackdrop.edgeFile = newTexture
		shieldFrame:SetBackdrop(barBackdrop)
		maelstromFrame:SetBackdrop(barBackdrop)
		LvBFrame:SetBackdrop(barBackdrop)
		LavaLashFrame:SetBackdrop(barBackdrop)
		SSFrame:SetBackdrop(barBackdrop)
		shockFrame:SetBackdrop(barBackdrop)
		windfuryFrame:SetBackdrop(barBackdrop)
		self:RedrawFrames()
	else
		if self.db.char.debug then
			self:Print("bar border texture not found. Trying to set "..self.db.char.barborder)
		end
	end
end

function ShockAndAwe:SetThreatThreshold(info, newValue)
	self.db.char.threatThreshold = newValue
	self:Print(L["config_Threat"]..newValue)
end

function ShockAndAwe:SetWidth(info,newValue)
	self.db.char.fWidth = newValue
	ShockAndAweBaseFrame:SetWidth(self.db.char.fWidth)
	
	shieldFrame.statusbar:SetWidth(self.db.char.fWidth - 6)
	shieldFrame:SetWidth(self.db.char.fWidth)
	shieldFrame.statusbar:SetValue(self.db.char.fWidth - 6)
	shieldFrame.spark:SetPoint("CENTER",shieldFrame.statusbar,"LEFT",self.db.char.fWidth - 3,-1)

	maelstromFrame.statusbar:SetWidth(self.db.char.fWidth - 6)
	maelstromFrame:SetWidth(self.db.char.fWidth)
	maelstromFrame.statusbar:SetValue(self.db.char.fWidth - 6)
	maelstromFrame.spark:SetPoint("CENTER",maelstromFrame.statusbar,"LEFT",self.db.char.fWidth - 3,-1)
	
	LvBFrame.statusbar:SetWidth(self.db.char.fWidth - 6)
	LvBFrame:SetWidth(self.db.char.fWidth)
	LvBFrame.statusbar:SetValue(self.db.char.fWidth - 6)
	LvBFrame.spark:SetPoint("CENTER",LvBFrame.statusbar,"LEFT",self.db.char.fWidth * self.db.char.LvBPercent - 3,-1)
	
	LavaLashFrame.statusbar:SetWidth(self.db.char.fWidth - 6)
	LavaLashFrame:SetWidth(self.db.char.fWidth)
	LavaLashFrame.statusbar:SetValue(self.db.char.fWidth - 6)
	LavaLashFrame.spark:SetPoint("CENTER",LavaLashFrame.statusbar,"LEFT",self.db.char.fWidth * self.db.char.LLPercent - 3,-1)
	
	SSFrame.statusbar:SetWidth(self.db.char.fWidth - 6)
	SSFrame:SetWidth(self.db.char.fWidth * self.db.char.SSPercent)
	SSFrame.statusbar:SetValue(self.db.char.fWidth - 6)
	SSFrame.spark:SetPoint("CENTER",SSFrame.statusbar,"LEFT",self.db.char.fWidth * self.db.char.SSPercent - 3,-1)
	
	shockFrame.statusbar:SetWidth(self.db.char.fWidth * self.db.char.ShockPercent - 6)
	shockFrame:SetWidth(self.db.char.fWidth * self.db.char.ShockPercent)
	shockFrame.statusbar:SetValue(self.db.char.fWidth * self.db.char.ShockPercent - 6)
	shockFrame.spark:SetPoint("CENTER",shockFrame.statusbar,"LEFT",self.db.char.fWidth * self.db.char.ShockPercent - 3,-1)
	
	windfuryFrame.statusbar:SetWidth(self.db.char.fWidth * self.db.char.WFProcPercent - 6)
	windfuryFrame:SetWidth((self.db.char.fWidth - 6)*self.db.char.WFProcPercent)
	windfuryFrame.spark:SetPoint("CENTER",windfuryFrame.statusbar,"LEFT",self.db.char.fWidth * self.db.char.WFProcPercent - 3,-1)
	self:Print("Frame width set to : "..self.db.char.fWidth)	
end

function ShockAndAwe:SetScale(info,newValue)
	self.db.char.scale = newValue
	ShockAndAweBaseFrame:SetScale(self.db.char.scale)
	self:Print("Scale set to : "..self.db.char.scale)
end

function ShockAndAwe:SetMSalpha(info,newValue)
	if self.db.char.msshow then
		self.db.char.colours.msalpha = newValue
		ShockAndAwe:SetMaelstromAlpha(self.db.char.colours.msalpha)
		self:Print(L["config_MSAlpha_ooc"]..self.db.char.colours.msalpha)
	end
end

function ShockAndAwe:SetMSalphaFull(info,newValue)
	if self.db.char.msshow then
		self.db.char.colours.msalphaFull = newValue
		ShockAndAwe:SetMaelstromAlpha(self.db.char.colours.msalphaFull)
		self:Print(L["config_MSAlpha_combat"]..self.db.char.colours.msalphaFull)
	end
end

function ShockAndAwe:SetMaelstromAlpha(alphaValue)
	maelstromFrame:SetBackdropColor(0, 0, 0, alphaValue * .2)
	maelstromFrame:SetBackdropBorderColor( 1, 1, 1, alphaValue)
	local colours = self.db.char.colours.maelstrom
	maelstromFrame.statusbar:SetStatusBarColor( colours.r, colours.g, colours.b, alphaValue)
end

-----------------------------------------
-- Colour choices getter/setters
-----------------------------------------

function ShockAndAwe:getWaterShieldColour(info)
	local colours = self.db.char.colours.watershield
	return colours.r, colours.g, colours.b, colours.a
end

function ShockAndAwe:setWaterShieldColour(info,r,g,b,a)
	self.db.char.colours.watershield.r = r
	self.db.char.colours.watershield.g = g
	self.db.char.colours.watershield.b = b
	self.db.char.colours.watershield.a = a
	self:UpdateShieldBar()
end

function ShockAndAwe:getLightningShieldColour(info)
	local colours = self.db.char.colours.lightningshield
	return colours.r, colours.g, colours.b, colours.a
end

function ShockAndAwe:setLightningShieldColour(info,r,g,b,a)
	self.db.char.colours.lightningshield.r = r
	self.db.char.colours.lightningshield.g = g
	self.db.char.colours.lightningshield.b = b
	self.db.char.colours.lightningshield.a = a
	self:UpdateShieldBar()
end

function ShockAndAwe:getEarthShieldColour(info)
	local colours = self.db.char.colours.earthshield
	return colours.r, colours.g, colours.b, colours.a
end

function ShockAndAwe:setEarthShieldColour(info,r,g,b,a)
	self.db.char.colours.earthshield.r = r
	self.db.char.colours.earthshield.g = g
	self.db.char.colours.earthshield.b = b
	self.db.char.colours.earthshield.a = a
	self:UpdateShieldBar()
end

function ShockAndAwe:getNoShieldColour(info)
	local colours = self.db.char.colours.noshield
	return colours.r, colours.g, colours.b, 0.2 -- use out of combat alpha
end

function ShockAndAwe:setNoShieldColour(info,r,g,b,a)
	self.db.char.colours.noshield.r = r
	self.db.char.colours.noshield.g = g
	self.db.char.colours.noshield.b = b
	self.db.char.colours.noshield.a = a
	self:UpdateShieldBar()
end

function ShockAndAwe:getEarthShockColour(info)
	local colours = self.db.char.colours.earthshock
	return colours.r, colours.g, colours.b, colours.a
end

function ShockAndAwe:setEarthShockColour(info,r,g,b,a)
	self.db.char.colours.earthshock.r = r
	self.db.char.colours.earthshock.g = g
	self.db.char.colours.earthshock.b = b
	self.db.char.colours.earthshock.a = a
	self:ShockBar(self.db.char.colours.earthshock)
end

function ShockAndAwe:getFlameShockColour(info)
	local colours = self.db.char.colours.flameshock
	return colours.r, colours.g, colours.b, colours.a
end

function ShockAndAwe:setFlameShockColour(info,r,g,b,a)
	self.db.char.colours.flameshock.r = r
	self.db.char.colours.flameshock.g = g
	self.db.char.colours.flameshock.b = b
	self.db.char.colours.flameshock.a = a
	self:ShockBar(self.db.char.colours.flameshock)
end

function ShockAndAwe:getFrostShockColour(info)
	local colours = self.db.char.colours.frostshock
	return colours.r, colours.g, colours.b, colours.a
end

function ShockAndAwe:setFrostShockColour(info,r,g,b,a)
	self.db.char.colours.frostshock.r = r
	self.db.char.colours.frostshock.g = g
	self.db.char.colours.frostshock.b = b
	self.db.char.colours.frostshock.a = a
	self:ShockBar(self.db.char.colours.frostshock)
end

function ShockAndAwe:getWindShockColour(info)
	local colours = self.db.char.colours.windshock
	return colours.r, colours.g, colours.b, colours.a
end

function ShockAndAwe:setWindShockColour(info,r,g,b,a)
	self.db.char.colours.windshock.r = r
	self.db.char.colours.windshock.g = g
	self.db.char.colours.windshock.b = b
	self.db.char.colours.windshock.a = a
	self:ShockBar(self.db.char.colours.windshock)
end

function ShockAndAwe:getMaelstromColour(info)
	local colours = self.db.char.colours.maelstrom
	return colours.r, colours.g, colours.b, colours.a
end

function ShockAndAwe:setMaelstromColour(info,r,g,b,a)
	self.db.char.colours.maelstrom.r = r
	self.db.char.colours.maelstrom.g = g
	self.db.char.colours.maelstrom.b = b
	self.db.char.colours.maelstrom.a = a
	self:MaelstromBar()
end

function ShockAndAwe:getStormstrikeColour(info)
	local colours = self.db.char.colours.stormstrike
	return colours.r, colours.g, colours.b, colours.a
end

function ShockAndAwe:setStormstrikeColour(info,r,g,b,a)
	self.db.char.colours.stormstrike.r = r
	self.db.char.colours.stormstrike.g = g
	self.db.char.colours.stormstrike.b = b
	self.db.char.colours.stormstrike.a = a
	self:StormstrikeBar()
end

function ShockAndAwe:getWindfuryColour(info)
	local colours = self.db.char.colours.windfury
	return colours.r, colours.g, colours.b, colours.a
end

function ShockAndAwe:setWindfuryColour(info,r,g,b,a)
	self.db.char.colours.windfury.r = r
	self.db.char.colours.windfury.g = g
	self.db.char.colours.windfury.b = b
	self.db.char.colours.windfury.a = a
	self:WFProcBar()
end

function ShockAndAwe:getLavaLashColour(info)
	local colours = self.db.char.colours.lavalash
	return colours.r, colours.g, colours.b, colours.a
end

function ShockAndAwe:setLavaLashColour(info,r,g,b,a)
	self.db.char.colours.lavalash.r = r
	self.db.char.colours.lavalash.g = g
	self.db.char.colours.lavalash.b = b
	self.db.char.colours.lavalash.a = a
	self:LavaLashBar()
end

function ShockAndAwe:getLavaBurstColour(info)
	local colours = self.db.char.colours.lavaburst
	return colours.r, colours.g, colours.b, colours.a
end

function ShockAndAwe:setLavaBurstColour(info,r,g,b,a)
	self.db.char.colours.lavaburst.r = r
	self.db.char.colours.lavaburst.g = g
	self.db.char.colours.lavaburst.b = b
	self.db.char.colours.lavaburst.a = a
	self:LavaBurstBar()
end

-----------------------------------------
-- Initialisation & Startup Routines
-----------------------------------------

function ShockAndAwe:OnInitialize()
	local AceConfigReg = LibStub("AceConfigRegistry-3.0")
	local AceConfigDialog = LibStub("AceConfigDialog-3.0")

	self.db = LibStub("AceDB-3.0"):New("ShockAndAweDBPC", ShockAndAwe.defaults, "char")
	LibStub("AceConfig-3.0"):RegisterOptionsTable("ShockAndAwe", getOptions, {"shockandawe", "saa"} )
	media.RegisterCallback(self, "LibSharedMedia_Registered")
	
	-- Add the options to blizzard frame (add them backwards so they show up in the proper order
	self.optionsFrame = AceConfigDialog:AddToBlizOptions("ShockAndAwe","ShockAndAwe")
	self.optionsFrame[L["About"]] = LibStub("LibAboutPanel").new("ShockAndAwe", "ShockAndAwe")
	self.db:RegisterDefaults(defaults)
	self:InitialiseUptime()
	self:CreateUptimeFrame()
	local version = GetAddOnMetadata("ShockAndAwe","Version")
	self.version = ("ShockAndAwe v%s (r%s)"):format(version, REVISION)
	self:Print(self.version.." Loaded.")
end

function ShockAndAwe:OnDisable()
    -- Called when the addon is disabled
end

function ShockAndAwe:OnEnable()
	self:LibSharedMedia_Registered()
	self:RegisterEvent("PLAYER_ENTERING_WORLD")
	self:RegisterEvent("UNIT_SPELLCAST_SUCCEEDED")
	self:RegisterEvent("CHAT_MSG_SPELL_SELF_DAMAGE")
	self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
	self:RegisterEvent("UNIT_AURA")
	self:RegisterEvent("UNIT_MANA")
	self:RegisterEvent("CHARACTER_POINTS_CHANGED")
	self:RegisterEvent("PLAYER_ENTERING_WORLD")
	self:RegisterEvent("PLAYER_REGEN_DISABLED")
	self:RegisterEvent("PLAYER_REGEN_ENABLED")
	self:RegisterEvent("PLAYER_TARGET_CHANGED");
end

function ShockAndAwe:LibSharedMedia_Registered()
	for k, v in pairs(media:List("statusbar")) do
		textures[v] = v
	end
	for k, v in pairs(media:List("border")) do
		borders[v] = v
	end
	for k, v in pairs(media:List("font")) do
		fonts[v] = v
	end
end

----------------------
-- Event Routines
----------------------

function ShockAndAwe:UNIT_MANA()
	self:UpdateShieldBar()
end

function ShockAndAwe:PLAYER_ENTERING_WORLD()
	self:SetBorderTexture(nil, self.db.char.border)
	self:SetBarBorderTexture(nil, self.db.char.barborder)
	self:SetTalentEffects()
	self:RedrawFrames()
end

function ShockAndAwe:UNIT_AURA()
	if (arg1 == "player") then
		self:UpdateShieldBar()
		if self.db.char.debug then
			self:Print("Unit Aura Event - MS Talents :"..self.db.char.maelstromTalents)
		end
		if self.db.char.msshow and self.db.char.maelstromTalents > 0 then
			updateActiveMaelstrom = true
			local currentStacks = ShockAndAwe:GetMaelstromInfo()
			if self.db.char.msstacks ~= ShockAndAwe:GetMaelstromInfo() then
				if self.db.char.barstext then
					maelstromFrame.text:SetText(currentStacks.." stacks")
				else 
					maelstromFrame.text:SetText("")
				end
				self:MaelstromBar()
			end
		end
	end
end

function ShockAndAwe:CHAT_MSG_SPELL_SELF_DAMAGE()
	if self.db.char.ssshow then
		if strfind(arg1, WindfuryCombatLog) then
			self:WFProcBar()
		end
	end
end

function ShockAndAwe:COMBAT_LOG_EVENT_UNFILTERED(...)
	if self.db.char.ssshow then
		--	local timestamp, eventtype, ?, srcGUID, srcName, srcFlags, dstGUID, dstName, dstFlags, spname = select(1, ...) or "nil";
		local sourceName = select(5, ...);
		local spellID = select(10, ...);
		if (sourceName == playerName) then
			if (spellID==25504 or spellID==33750) then -- note that 25504 is a MH WF proc, 33750 is an OH proc
				self:WFProcBar()
			end
		end
	end
end

function ShockAndAwe:UNIT_SPELLCAST_SUCCEEDED()
	if arg1 == "player" then -- skip if someone else casting
		if self.db.char.ssshow then
			if arg2 == stormstrike_cast then
				self:StormstrikeBar()
			end
		end
		if self.db.char.shieldshow then
			self:SetShieldType(arg2)
		end	
		if self.db.char.shockshow then
			if arg2 == earthshock_cast then
				local colours = self.db.char.colours.earthshock
				self.db.char.lastshock = earthshock_cast
				self:ShockBar(colours)
			elseif arg2 == flameshock_cast then
				local colours = self.db.char.colours.flameshock
				self.db.char.lastshock = flameshock_cast
				self:ShockBar(colours)
			elseif arg2 == frostshock_cast then
				local colours = self.db.char.colours.frostshock
				self.db.char.lastshock = frostshock_cast
				self:ShockBar(colours)
			elseif arg2 == windshock_cast then
				local colours = self.db.char.colours.windshock
				self.db.char.lastshock = windshock_cast
				self:ShockBar(colours)
			end
		end
		if self.db.char.llshow then
			if arg2 == lavalash_cast then 
				self:LavaLashBar()
			end
		end
		if arg2 == lavaburst_cast then -- process LavaBurst bar even if not showing LavaBurst bar
			self:LavaBurstBar()
		end
	end
end

function ShockAndAwe:CHARACTER_POINTS_CHANGED()
	self:SetTalentEffects()
	self:CreateBaseFrame()
end

function ShockAndAwe:PLAYER_REGEN_DISABLED() -- Entering Combat
	if self.db.char.msshow then
		self:SetMaelstromAlpha(self.db.char.colours.msalpha) -- set maelstrom frame to in combat alpha
	end
	if self.db.char.uptime.show then
		if not self.uptime.incombat then
			self.uptime.incombat = true
			-- reset last fight data on entering combat
			self:InitialiseUptimeBuffs(self.uptime.lastfight)
			self.uptime.currentTime = GetTime()
			self:UpdateUptime()
			self:UpdateUptimeFrames(true)
			self.uptime.TimerEvent = self:ScheduleRepeatingTimer("UpdateUptime", 0.1, nil);
		end
	end
	if self.db.char.maelstromTalents == 0 then -- check MW talents again to counter Player_Entering_World bug
		self:SetTalentEffects()
		self:CreateBaseFrame()
	end
	lastshock = ""
	updateShockIcon = true
end

function ShockAndAwe:PLAYER_REGEN_ENABLED() -- Leaving Combat
	maelstromFrame:Hide()
	shockIconFrame:Hide()
	mwIconFrame:Hide()
	if self.db.char.uptime.show then
		if self.uptime.incombat then
			self:UpdateUptime()
			self.uptime.incombat = false
			self:UpdateUptimeFrames(true)
			self:CancelTimer(self.uptime.TimerEvent , false)
		end
	end
end

function ShockAndAwe:PLAYER_TARGET_CHANGED()
	if InCombatLockdown() then
		updateShockIcon = true
	end
end
-------------------------
-- Shield bar routines
-------------------------

function ShockAndAwe:GetShieldInfo()
	local index = 1
	while UnitBuff("PLAYER", index) do
		local name, _, _, count, _, _, shieldExpires = UnitBuff("PLAYER", index)
		ShieldTime = shieldExpires
		if self:SetShieldType(name) then
			return count, name
		end
		index = index + 1
	end
	return 0, 0, ""
end

function ShockAndAwe:GetFlameShockInfo()
	local index = 1
	while UnitDebuff("target", index) do
		local name, _, _, count, _, _, shockExpires, isMine = UnitDebuff("target", index)
		if name == flameshock_cast and isMine then -- don't return true on finding another player's FS
			return true, shockExpires - GetTime()
		end
		index = index + 1
	end
	return false, 0
end

function ShockAndAwe:SetShieldType(name)
	local colours = self.db.char.colours;
	if name == WaterShieldCast then
		self:ShieldBar(colours.watershield.r, colours.watershield.g, colours.watershield.b, colours.watershield.a)
		return true
	elseif name == LightningShieldCast then
		self:ShieldBar(colours.lightningshield.r, colours.lightningshield.g, colours.lightningshield.b, colours.lightningshield.a)
		return true
	elseif name == EarthShieldActive then
		self:ShieldBar(colours.earthshield.r, colours.earthshield.g, colours.earthshield.b, colours.earthshield.a)
		return true
	end
	return false
end	

function ShockAndAwe:UpdateShieldBar()
	if self.db.char.shieldshow then
		local orbs, shieldType = ShockAndAwe:GetShieldInfo()
		if orbs == 0 then
			updateActiveShield = false
			shieldFrame.spark:Hide()
			shieldFrame.statusbar:SetValue(600)
			if self.db.char.barstext then
				shieldFrame.text:SetText("No Shield Active")
			else
				shieldFrame.text:SetText("")
			end
		else
			updateActiveShield = true
			shieldFrame.spark:Show()
			shieldFrame.statusbar:SetValue(ShieldTime - GetTime())
			if self.db.char.barstext then
				shieldFrame.text:SetText(orbs.." orbs remaining")
			else
				shieldFrame.text:SetText("")
			end
		end
		if not updateActiveShield then
			local colours = self.db.char.colours;
			if UnitMana("player") == UnitManaMax("player") then
				-- shield down but at max mana
				shieldFrame.statusbar:SetStatusBarColor(colours.noshield.r, colours.noshield.g, colours.noshield.b, .2)
				shieldFrame:SetBackdropBorderColor(1, 1, 1, .2);
			else 
				-- shield down but not at max mana
				shieldFrame.statusbar:SetStatusBarColor(colours.noshield.r, colours.noshield.g, colours.noshield.b, 1)
				shieldFrame:SetBackdropBorderColor(1, 1, 1, 1);
			end
		end
		shieldFrame.text:Show()
		self:SetShieldType(shieldType)
		if not self.db.char.activeshields and orbs > 0 then
			shieldFrame:Hide() -- hide frame if shield is active and option to show active fields is off
		else
			shieldFrame:Show()
		end 
	else
		shieldFrame:Hide()
	end
end

---------------------------
-- Buff Info functions
---------------------------

function ShockAndAwe:GetMaelstromInfo()
	local index = 1
	while UnitBuff("PLAYER", index) do
		local name, _, _, count, _, _, maelstromTime = UnitBuff("PLAYER", index)
		if name == Maelstrom_Active then
			return count, maelstromTime
		end
		index = index + 1
	end
	return 0, 0 
end

---------------------------
-- functions
---------------------------

function ShockAndAwe:RedrawFrames()
	self:CreateBaseFrame()
	self:CreateUptimeFrame()
end

function ShockAndAwe:SetTalentEffects()
	if self.db.char.debug then
		self:Print("Entered SetTalentEffects")
	end
	local currRank, maxRank
	_, _, _, _, currRank, maxRank = GetTalentInfo(2,27)
	self.db.char.maelstromTalents = currRank
	_, _, _, _, currRank, maxRank = GetTalentInfo(2,22) -- lava lash
	if currRank == 0 then
		self.db.char.lavaLashTalented = false
	else
		self.db.char.lavaLashTalented = true	
	end
	_, _, _, _, currRank, maxRank = GetTalentInfo(2,23) 
	self.db.char.impSS = currRank
	_, _, _, _, currRank, maxRank = GetTalentInfo(1,6) 
	local reverberation = currRank
	if self.db.char.debug then
		if self.db.char.lavaLashTalented then
			self:Print("maelstrom talents : "..self.db.char.maelstromTalents.." lava lash true")
		else
			self:Print("maelstrom talents : "..self.db.char.maelstromTalents.." lava lash false")
		end
	end
	if self.db.char.maelstromTalents == 0 then
		updateActiveMaelstrom = false
	end
	if UnitLevel("player") < 75 then
		self.db.char.lvbshow = false
	end
	 -- TODO replace this with programatic gear check if person has arena gear
	if self.db.char.arena then
		self.db.char.SSlen = 9 - self.db.char.impSS -- arena bonus reduces by 1 sec.
	else
		self.db.char.SSlen = 10 - self.db.char.impSS
	end
	self.db.char.SSPercent = 1 -- make Stormstrike bar full width
	self.db.char.LLPercent = self.db.char.LLlen / self.db.char.SSlen
	self.db.char.LvBPercent = self.db.char.LvBlen / self.db.char.SSlen
	self.db.char.ShockLen = 6 - reverberation * 0.2
	self.db.char.ShockPercent = self.db.char.ShockLen / self.db.char.SSlen
	self.db.char.WFProcPercent = 3 / self.db.char.SSlen
end

function ShockAndAwe:DisplayVersion()
	self:Print(self.version)
end

function ShockAndAwe:CreateBaseFrame()
	ShockAndAweBaseFrame:SetScale(self.db.char.scale)
	ShockAndAweBaseFrame:SetFrameStrata("BACKGROUND")
	ShockAndAweBaseFrame:SetWidth(self.db.char.fWidth + self.db.char.fHeight / 7)
	ShockAndAweBaseFrame:SetHeight(self.db.char.fHeight)
	ShockAndAweBaseFrame:SetBackdrop(frameBackdrop)
	ShockAndAweBaseFrame:SetBackdropColor(1, 1, 1, 0)
	ShockAndAweBaseFrame:SetMovable(true)
	ShockAndAweBaseFrame:RegisterForDrag("LeftButton")
	ShockAndAweBaseFrame:SetPoint(self.db.char.point, self.db.char.relativeTo, self.db.char.relativePoint, self.db.char.xOffset, self.db.char.yOffset)
	ShockAndAweBaseFrame:SetScript("OnDragStart", 
		function()
			ShockAndAweBaseFrame:StartMoving();
		end );
	ShockAndAweBaseFrame:SetScript("OnDragStop",
		function()
			ShockAndAweBaseFrame:StopMovingOrSizing();
			ShockAndAweBaseFrame:SetScript("OnUpdate", nil);
			self:FinishedMoving(false);
		end );
	ShockAndAweBaseFrame:Show()
	self.db.char.barshow = false
	
	local barHeight = self.db.char.fHeight / 7
	local baseOffset = (-1 * barHeight) + 3
	local barCount = 0
	local colours = self.db.char.colours.noshield
	ShockAndAwe:SetBarFrame(shieldFrame, 
					self.db.char.fWidth, barHeight,
					0, 1,
					0, 600, 
					600, self.db.char.fWidth - 6,
					colours.r, colours.g, colours.b, colours.a)
	if self.db.char.shieldshow then
		barCount = barCount + 1 -- we will use shield frame 
	end
	colours = self.db.char.colours.maelstrom
	ShockAndAwe:SetBarFrame(maelstromFrame, 
					self.db.char.fWidth, barHeight,
					barCount * baseOffset, 1,
					0, 30, 
					6, 1, 
					colours.r, colours.g, colours.b, self.db.char.colours.msalpha)
	if self.db.char.msshow then
		barCount = barCount + 1 -- we will use shield frame 
	end
	colours = self.db.char.colours.lavaburst
	ShockAndAwe:SetBarFrame(LvBFrame, 
					self.db.char.fWidth * self.db.char.LvBPercent, barHeight,
					barCount * baseOffset, 1,
					0, self.db.char.LvBlen, 
					6, 1, 
					colours.r, colours.g, colours.b, colours.a)
	if self.db.char.lvbshow then
		barCount = barCount + 1 -- we will use LavaBurst frame 
	end
	colours = self.db.char.colours.stormstrike
	ShockAndAwe:SetBarFrame(SSFrame, 
					self.db.char.fWidth * self.db.char.SSPercent, barHeight, 
					barCount * baseOffset, 1,
					0, self.db.char.SSlen, 
					0.4, 0.4, 
					colours.r, colours.g, colours.b, colours.a)
	colours = self.db.char.colours.windfury
	ShockAndAwe:SetBarFrame(windfuryFrame, 
					self.db.char.fWidth * self.db.char.WFProcPercent, barHeight, 
					barCount * baseOffset, 2,
					0, 3, 
					3, (self.db.char.fWidth * self.db.char.WFProcPercent - 6),
					colours.r, colours.g, colours.b, colours.a)
	if self.db.char.ssshow then
		barCount = barCount + 1 
	end	
	ShockAndAwe:SetBarFrame(shockFrame, 
					self.db.char.fWidth * self.db.char.ShockPercent, barHeight, 
					barCount * baseOffset, 1,
					0, self.db.char.ShockLen, 
					1, 0.8, 
					0, 1, .3, .9)
	if self.db.char.shockshow then
		barCount = barCount + 1
	end
	ShockAndAwe:SetBarFrame(LavaLashFrame, 
					self.db.char.fWidth * self.db.char.LLPercent, barHeight, 
					barCount * baseOffset, 1,
					0, self.db.char.LLlen, 
					6, 1, 
					colours.r, colours.g, colours.b, colours.a)
	if self.db.char.llshow and self.db.char.lavaLashTalented then
		barCount = barCount + 1 -- we will use LavaLash frame 
	end
	shockIconFrame:SetWidth(barHeight) -- same as height to get square box
	shockIconFrame:SetHeight(barHeight)
	shockIconFrame:SetPoint("TOPRIGHT", shockFrame, "TOPLEFT")
	shockIconFrame:Hide()
	mwIconFrame:SetWidth(barHeight) -- same as height to get square box
	mwIconFrame:SetHeight(barHeight)
	mwIconFrame:SetPoint("TOPRIGHT", maelstromFrame, "TOPLEFT")
	mwIconFrame:Hide()
	
	self:UpdateShieldBar()
end

function ShockAndAwe:SetBarFrame(frameName, barWidth, barHeight, frameOffset, frameLevel, minValue, maxValue, frameValue, frameSpark, frameR, frameG, frameB, frameAlpha)
	frameName:SetFrameStrata("LOW")
	frameName:SetWidth(barWidth)
	frameName:SetHeight(barHeight)
	frameName:ClearAllPoints()
	frameName:SetPoint("TOPLEFT", ShockAndAweBaseFrame, "TOPLEFT", barHeight, frameOffset)
	frameName:SetBackdrop(barBackdrop);
	frameName:SetBackdropColor(0, 0, 0, .2);
	frameName:SetBackdropBorderColor( 1, 1, 1, 1);
	frameName:EnableMouse(false)
	if not frameName.statusbar then
		frameName.statusbar = CreateFrame("StatusBar", nil, frameName)
	end
	frameName.statusbar:SetFrameLevel(frameLevel)
	frameName.statusbar:ClearAllPoints()
	frameName.statusbar:SetHeight(barHeight - 6)
	frameName.statusbar:SetWidth(barWidth - 6)
	frameName.statusbar:SetPoint("TOPLEFT", frameName, "TOPLEFT", 3, -3)
	frameName.statusbar:SetStatusBarTexture(media:Fetch("statusbar", self.db.char.texture))
	frameName.statusbar:SetStatusBarColor(frameR, frameG, frameB, frameAlpha)
	frameName.statusbar:SetMinMaxValues(minValue,maxValue)
	frameName.statusbar:SetValue(frameValue)
	
	if not frameName.spark then
		frameName.spark = frameName.statusbar:CreateTexture(nil, "OVERLAY")
	end
	frameName.spark:SetTexture("Interface\\CastingBar\\UI-CastingBar-Spark")
	frameName.spark:SetWidth(16)
	frameName.spark:SetHeight(barHeight + 16)
	frameName.spark:SetBlendMode("ADD")
	frameName.spark:SetPoint("CENTER",frameName.statusbar,"BOTTOMLEFT",(barWidth - 6)* frameSpark, -1)
	frameName.spark:Show()
	
	if not frameName.text then
		frameName.text = frameName:CreateFontString(nil,"OVERLAY")
	end
	local barfont = media:Fetch("font", self.db.char.barfont)
	frameName.text:SetFont(barfont, self.db.char.barfontsize)
	frameName.text:ClearAllPoints()
	frameName.text:SetTextColor(1, 1, 1, 1)
	frameName.text:SetPoint("CENTER", frameName, "CENTER");
	frameName.text:SetText("")

	frameName:SetScript("OnUpdate", 
		function()
			OnUpdate();
		end );
	
	frameName:Hide()
end

function ShockAndAwe:ResetAll()
	ShockAndAweBaseFrame:ClearAllPoints()
	self.db.char.point = defaults.char.point
	self.db.char.relativeTo = defaults.char.relativeTo 
	self.db.char.relativePoint = defaults.char.relativePoint
	self.db.char.xOffset = defaults.char.xOffset
	self.db.char.yOffset = defaults.char.yOffset
	self.db.char.fWidth = defaults.char.fWidth
	self.db.char.fHeight = defaults.char.fHeight
	self.db.char.scale = defaults.char.scale
	self.db.char.barfont = defaults.char.barfont
	self.db.char.barfontsize = defaults.char.barfontsize
	self.db.char.bartexture = defaults.char.bartexture
	self.db.char.texture = defaults.char.texture
	barshow = true
	ShockAndAweBaseFrame:SetPoint(self.db.char.point, self.db.char.relativeTo, self.db.char.relativePoint, self.db.char.xOffset, self.db.char.yOffset)
	ShockAndAwe:SetTalentEffects()
	self:RedrawFrames()
	self.db.char.barshow = true -- so that call to ShowHideBars resets to false
	self:ShowHideBars()
	self:Print(L["config_reset"])
end

function ShockAndAwe:DebugTalents()
	local numTabs = GetNumTalentTabs();
	for t=1, numTabs do
		DEFAULT_CHAT_FRAME:AddMessage(GetTalentTabInfo(t)..":");
		local numTalents = GetNumTalents(t);
		for i=1, numTalents do
			nameTalent, icon, tier, column, currRank, maxRank= GetTalentInfo(t,i);
			DEFAULT_CHAT_FRAME:AddMessage("- "..i..":"..nameTalent..": "..currRank.."/"..maxRank);
		end
	end
end

function ShockAndAwe:DebugFrameValues()
	self:Print("SSlen : "..self.db.char.SSlen)
	self:Print("SSPercent : "..self.db.char.SSPercent )
	self:Print("ShockLen : "..self.db.char.ShockLen)
	self:Print("ShockPercent : "..self.db.char.ShockPercent )
	self:Print("WFProcPercent : "..self.db.char.WFProcPercent)
end

function ShockAndAwe:WFProcBar()
	local colours = self.db.char.colours.windfury
	windfuryFrame.statusbar:SetStatusBarColor(colours.r, colours.g, colours.b, colours.a)
	windfuryFrame:Show()
	updateActiveWFProc = true
	WFProcTime = GetTime() + 3
	WFPMin, WFPMax = windfuryFrame.statusbar:GetMinMaxValues()
end

function ShockAndAwe:ShieldBar(shieldR, shieldB, shieldG, shieldalpha)
	shieldFrame.statusbar:SetStatusBarColor(shieldR, shieldB, shieldG, shieldalpha)
	shieldFrame:SetBackdropBorderColor( 1, 1, 1, shieldalpha);
	shieldFrame.spark:Show()
	updateActiveShield = true
	ShieldMin, ShieldMax = shieldFrame.statusbar:GetMinMaxValues()
end

function ShockAndAwe:MaelstromBar()
	local colours = self.db.char.colours.maelstrom
	maelstromFrame.statusbar:SetStatusBarColor(colours.r, colours.g, colours.b, self.db.char.colours.msalpha)
	maelstromFrame:SetBackdropBorderColor( 1, 1, 1, self.db.char.colours.msalpha);
	maelstromFrame.spark:Show()
	maelstromFrame:Show()
	updateActiveMaelstrom = true
	MaelstromMin, MaelstromMax = maelstromFrame.statusbar:GetMinMaxValues()
end

function ShockAndAwe:StormstrikeBar()
	local colours = self.db.char.colours.stormstrike
	SSFrame.statusbar:SetStatusBarColor(colours.r, colours.g, colours.b, colours.a)
	SSFrame:Show()
	updateActiveSS = true
	SSTime = GetTime() + self.db.char.SSlen
	SSmin, SSmax = SSFrame.statusbar:GetMinMaxValues()
end

function ShockAndAwe:LavaLashBar()
	local colours = self.db.char.colours.lavalash
	LavaLashFrame.statusbar:SetStatusBarColor(colours.r, colours.g, colours.b, colours.a)
	LavaLashFrame:Show()
	updateActiveLavaLash = true
	LLTime = GetTime() + self.db.char.LLlen
	LLMin, LLMax = LavaLashFrame.statusbar:GetMinMaxValues()
end

function ShockAndAwe:LavaBurstBar()
	local colours = self.db.char.colours.lavaburst
	LvBFrame.statusbar:SetStatusBarColor(colours.r, colours.g, colours.b, colours.a)
	updateActiveLvB = true
	lvbOnCooldown = true
	LvBTime = GetTime() + self.db.char.LvBlen
	LvBMin, LvBMax = LvBFrame.statusbar:GetMinMaxValues()
	if self.db.char.lvbshow then
		LvBFrame:Show()
	end
end

function ShockAndAwe:ShockBar(colours)
	shockFrame.statusbar:SetStatusBarColor(colours.r, colours.g, colours.b, colours.a)
	shockFrame:Show()
	updateActiveShock = true
	updateShockIcon = true
	ShockTime = GetTime() + 6
	ShockMin, ShockMax = shockFrame.statusbar:GetMinMaxValues()
end

function ShockAndAwe:DurationString(duration)
    local string = (("%1.1f"):format(duration % 60)) .. "s";
    
    if (duration >= 60) then
        duration = floor(duration - (duration % 60)) / 60; -- minutes
        
        string = (duration % 60) .."m " .. string;
        
        if (duration >= 60) then
            duration = (duration - (duration % 60)) / 60; -- hours
            string = duration .. "h " .. string;
        end
    end
    return string
end

function ShockAndAwe:SetMWIcon()
	local _, _, lbicon = GetSpellInfo(49238)
--  lava burst as of build 9028 no longer works with MW
--  local _, _, lvbicon = GetSpellInfo(60043)
--	local icon = lvbicon
--	if UnitLevel("player")<75 then
--		icon = lbicon
--	else
--		if lvbOnCooldown then
--			icon = lbicon
--		end
--	end
	mwIconFrame:SetBackdrop({ bgFile = icon })
	mwIconFrame:Show()
end

oldThreat = 0
oldThreatTime = GetTime()

function OnUpdate()
	if ShockAndAwe.db.char.debug then
		local isTanking, state, scaledPercent, rawPercent, threatValue = UnitDetailedThreatSituation("player", "target")
		if not state then state = 0 end
		if not scalePercent then scaledPercent = 0 end
		if not rawPercent then rawPercent = 0 end
		if not threatValue then threatValue = 0 end
		if threatValue ~= oldThreat then
			ShockAndAwe:Print(("%1.2f"):format(GetTime() - oldThreatTime).."s - state :"..state.." scaled :"..("%1.2f"):format(100*scaledPercent).."% raw : "..rawPercent.."% - value :"..threatValue)
			oldThreat = threatValue
		end
	end
	
	local width = ShockAndAwe.db.char.fWidth - 6
	local timeLeft = 0
	if updateActiveMaelstrom then
		local maelstromTime
		ShockAndAwe.db.char.msstacks, maelstromTime = ShockAndAwe:GetMaelstromInfo()
		timeLeft = maelstromTime - GetTime()
		if ShockAndAwe.db.char.msstacks == 5 then
			ShockAndAwe:SetMaelstromAlpha(ShockAndAwe.db.char.colours.msalphaFull)
			if ShockAndAwe.db.char.mwicon then
				ShockAndAwe:SetMWIcon()
			end
		else
			ShockAndAwe:SetMaelstromAlpha(ShockAndAwe.db.char.colours.msalpha)
			mwIconFrame:Hide()
		end		
		maelstromFrame.statusbar:SetValue(timeLeft)
		maelstromFrame.spark:SetPoint("CENTER",maelstromFrame.statusbar,"LEFT", timeLeft/30 * width,-1)
		if maelstromTime < GetTime() then
			maelstromFrame:Hide()
			updateActiveMaelstrom = false
		else
			maelstromFrame:Show()
		end		
	end
	if updateActiveSS then
		timeLeft = SSTime - GetTime()
		SSFrame.statusbar:SetValue(timeLeft)
		SSFrame.spark:SetPoint("CENTER",SSFrame.statusbar,"LEFT", timeLeft/SSmax * width * ShockAndAwe.db.char.SSPercent,-1)
		if SSTime < GetTime() then
			SSFrame:Hide()
			updateActiveSS = false
		end
	end
	if updateActiveLavaLash then
		timeLeft = LLTime - GetTime()
		LavaLashFrame.statusbar:SetValue(timeLeft)
		LavaLashFrame.spark:SetPoint("CENTER",LavaLashFrame.statusbar,"LEFT", timeLeft/LLMax * width * ShockAndAwe.db.char.LLPercent ,-1)
		if LLTime < GetTime() then
			LavaLashFrame:Hide()
			updateActiveLavaLash = false
		end
	end
	if updateActiveLvB then
		timeLeft = LvBTime - GetTime()
		LvBFrame.statusbar:SetValue(timeLeft)
		LvBFrame.spark:SetPoint("CENTER",LvBFrame.statusbar,"LEFT", timeLeft/LvBMax * width * ShockAndAwe.db.char.LvBPercent ,-1)
		if LvBTime < GetTime() then
			LvBFrame:Hide()
			updateActiveLvB = false
			lvbOnCooldown = false
		end
	end
	if updateActiveShock then
		timeLeft = ShockTime - GetTime()
		shockFrame.statusbar:SetValue(timeLeft)
		shockFrame.spark:SetPoint("CENTER",shockFrame.statusbar,"LEFT", timeLeft/ShockMax * width * ShockAndAwe.db.char.ShockPercent ,-1)
		if ShockTime < GetTime() then
			shockFrame:Hide()
			updateActiveShock = false
		end
	end
	if updateShockIcon then
		local icon = nil
		if ShockAndAwe.db.char.rotationshow then
			if ShockAndAwe:GetFlameShockInfo() and ShockAndAwe.db.char.lastshock ~= earthshock_cast then 
				-- flame shock debuff on target so next should be an Earth Shock
				_, _, icon = GetSpellInfo(49231)
			else
				-- no flame shock debuff or earth shock last time so next should be Flame Shock
				_, _, icon = GetSpellInfo(49233)
			end
		end
		if ShockAndAwe.db.char.windshockshow and (GetNumPartyMembers()>=4 or GetNumRaidMembers()>=5) then
			-- don't use windshock option if soloing
			local _, state, _, raw = UnitDetailedThreatSituation("player", "target")
			-- state 2 or 3 = tanking = not what an Enh Shammy should be doing
			-- state 0 threat < 100%, state 1 threat >=100%
			if not state then state = 0 end
			if not raw then raw = 0 end
			if  state >1 or raw > ShockAndAwe.db.char.threatThreshold then
				-- we have exceeded threshold or have already started tanking so wind shock needed.
				_, _, icon = GetSpellInfo(57994)
			end
		end
		if icon and InCombatLockdown() then -- only show icon if in combat.
			shockIconFrame:SetBackdrop({ bgFile = icon })
			shockIconFrame:Show()
			updateShockIcon = false
		else
			shockIconFrame:Hide()
		end
	end
	if updateActiveShield then
		timeLeft = ShieldTime - GetTime()
		shieldFrame.statusbar:SetValue(timeLeft)
		shieldFrame.spark:SetPoint("CENTER",shieldFrame.statusbar,"LEFT", timeLeft/ShieldMax * width,-1)
		if ShieldTime < GetTime() then
			updateActiveShield = false
		end
	end
	if updateActiveWFProc then
		timeLeft = WFProcTime - GetTime()
		windfuryFrame.statusbar:SetValue(timeLeft)
		windfuryFrame.spark:SetPoint("CENTER",windfuryFrame.statusbar,"LEFT", timeLeft/WFPMax * width * ShockAndAwe.db.char.WFProcPercent ,-1)
		if WFProcTime < GetTime() then
			windfuryFrame:Hide()
			updateActiveWFProc = false
		end
	end
end

---------------------------
-- Uptime functions
---------------------------

function ShockAndAwe:InitialiseUptime()
	self.uptime = {}
	self.uptime = {
		session = {},
		lastfight = {},
		incombat = false,
		TimerEvent = nil,
		currentTime = nil,
	}
	self:InitialiseUptimeBuffs(self.uptime.session)
	self:InitialiseUptimeBuffs(self.uptime.lastfight)
end

function ShockAndAwe:InitialiseUptimeBuffs(timeframe)
	timeframe.totalTime = 0
	if not timeframe.buffs then
		timeframe.buffs = {}
		if self.db.char.debug then
			self:Print("reset buff")
		end
	end
	if not timeframe.buffs[ElementalDevastation] then
		timeframe.buffs[ElementalDevastation] = {}
		timeframe.buffs[ElementalDevastation].name = ElementalDevastation
		_, _, timeframe.buffs[ElementalDevastation].icon = GetSpellInfo(29180)
		if self.db.char.debug then
			self:Print("reset ED")
		end
	end
	if not timeframe.buffs[Flurry] then
		timeframe.buffs[Flurry] = {}
		timeframe.buffs[Flurry].name = Flurry
		_, _, timeframe.buffs[Flurry].icon = GetSpellInfo(16284)
		if self.db.char.debug then
			self:Print("reset Flurry")
		end
	end
	if not timeframe.buffs[UnleashedRage] then
		timeframe.buffs[UnleashedRage] = {}
		timeframe.buffs[UnleashedRage].name = UnleashedRage
		_, _, timeframe.buffs[UnleashedRage].icon = GetSpellInfo(30807)
		if self.db.char.debug then
			self:Print("reset UR")
		end
	end
	timeframe.buffs[ElementalDevastation].uptime = 0
	timeframe.buffs[Flurry].uptime = 0
	timeframe.buffs[UnleashedRage].uptime = 0
end

function ShockAndAwe:UpdateUptime()
	if not self.uptime.incombat then
		return
	end
	local currentTime = GetTime()
	-- add conditional safety measure - we should never have no current time but to be sure...
	if  not self.uptime.currentTime then
		self.uptime.currentTime = currentTime
	end
	local diffTime = currentTime - self.uptime.currentTime
	
	self.uptime.session.totalTime = self.uptime.session.totalTime + diffTime;
	self.uptime.lastfight.totalTime = self.uptime.lastfight.totalTime + diffTime;
	
	local i = 1
	local buff = UnitBuff("player", i)
	while buff do
		if self.uptime.session.buffs[buff] then
			self.uptime.session.buffs[buff].uptime = self.uptime.session.buffs[buff].uptime + diffTime
		end
		if self.uptime.lastfight.buffs[buff] then
			self.uptime.lastfight.buffs[buff].uptime = self.uptime.lastfight.buffs[buff].uptime + diffTime
		end		
		i = i + 1
		buff = UnitBuff("player", i)
	end	
	self.uptime.currentTime = currentTime
	self:UpdateUptimeFrames(false)
end

function ShockAndAwe:CreateUptimeFrame()
	SAAUptimeFrame:ClearAllPoints()
	SAAUptimeFrame:SetScale(self.db.char.uptime.scale)
	SAAUptimeFrame:SetFrameStrata("BACKGROUND")
	SAAUptimeFrame:SetWidth(self.db.char.uptime.fWidth + self.db.char.uptime.barHeight)
	SAAUptimeFrame:SetHeight(self.db.char.uptime.fHeight + 16)
	SAAUptimeFrame:SetBackdrop(frameBackdrop)
	SAAUptimeFrame:SetBackdropColor(0, 0, 0, self.db.char.uptime.alpha)
	SAAUptimeFrame:SetMovable(true)
	SAAUptimeFrame:RegisterForDrag("LeftButton")
	SAAUptimeFrame:SetPoint(self.db.char.uptime.point, self.db.char.uptime.relativeTo, self.db.char.uptime.relativePoint, self.db.char.uptime.xOffset, self.db.char.uptime.yOffset)
	SAAUptimeFrame:SetScript("OnDragStart", 
		function()
			SAAUptimeFrame:StartMoving();
		end );
	SAAUptimeFrame:SetScript("OnDragStop",
		function()
			SAAUptimeFrame:StopMovingOrSizing();
			SAAUptimeFrame:SetScript("OnUpdate", nil);
			self:FinishedMoving(true);
		end );
	
	local barfont = media:Fetch("font", self.db.char.barfont)
	if not SAAUptimeFrame.topText then
		SAAUptimeFrame.topText = SAAUptimeFrame:CreateFontString(nil, "OVERLAY")
	end
	SAAUptimeFrame.topText:SetTextColor(1,1,1,1)
	SAAUptimeFrame.topText:SetFont(barfont, self.db.char.barfontsize)
	SAAUptimeFrame.topText:SetPoint("TOP", SAAUptimeFrame, "TOP", 0, - 2)
	SAAUptimeFrame.topText:SetText(L["uptime_session"])
	
	local baseOffset = (-1 * self.db.char.uptime.fHeight / 8) - 2 -- 6 bars + top line + middle line 
	if not SAAUptimeFrame.middleText then
		SAAUptimeFrame.middleText = SAAUptimeFrame:CreateFontString(nil, "OVERLAY")
	end
	SAAUptimeFrame.middleText:SetTextColor(1,1,1,1)
	SAAUptimeFrame.middleText:SetFont(barfont, self.db.char.barfontsize)
	SAAUptimeFrame.middleText:SetPoint("TOP", SAAUptimeFrame, "TOP", 0, 4 * baseOffset - 2)
	SAAUptimeFrame.middleText:SetText(L["uptime_lastfight"])
	if self.db.char.uptime.show then
		SAAUptimeFrame:Show()
	else
		SAAUptimeFrame:Hide()
	end
	local session = self.uptime.session
	local lastfight = self.uptime.lastfight
	
	self:CreateUptimeBarFrame(session.buffs[Flurry], self.db.char.uptime.flurry, baseOffset)
	self:CreateUptimeBarFrame(session.buffs[UnleashedRage], self.db.char.uptime.ur, 2 * baseOffset)
	self:CreateUptimeBarFrame(session.buffs[ElementalDevastation], self.db.char.uptime.ed, 3 * baseOffset)
	
	self:CreateUptimeBarFrame(lastfight.buffs[Flurry], self.db.char.uptime.flurry, 5 * baseOffset)
	self:CreateUptimeBarFrame(lastfight.buffs[UnleashedRage], self.db.char.uptime.ur, 6 * baseOffset)
	self:CreateUptimeBarFrame(lastfight.buffs[ElementalDevastation], self.db.char.uptime.ed, 7 * baseOffset)
end

function ShockAndAwe:CreateUptimeBarFrame(buff, buffColours, frameOffset)
	if not buff.barFrame then
		buff.barFrame = CreateFrame("Frame", nil, SAAUptimeFrame)
	end
	buff.barFrame:SetFrameStrata("LOW")
	buff.barFrame:SetWidth(self.db.char.uptime.barWidth + self.db.char.uptime.barHeight)
	buff.barFrame:SetHeight(self.db.char.uptime.barHeight)
	buff.barFrame:ClearAllPoints()
	buff.barFrame:SetPoint("TOPLEFT", SAAUptimeFrame, "TOPLEFT", self.db.char.uptime.barHeight, frameOffset)
	buff.barFrame:SetScript("OnUpdate", function() self:UpdateUptimeFrames(false); end );
	
	if not buff.barFrame.buffIcon then
		buff.barFrame.buffIcon = CreateFrame("Frame", nil, buff.barFrame)
	end
	buff.barFrame.buffIcon:SetWidth(self.db.char.uptime.barHeight)
	buff.barFrame.buffIcon:SetHeight(self.db.char.uptime.barHeight)
	buff.barFrame.buffIcon:SetBackdrop({ bgFile = buff.icon })
	buff.barFrame.buffIcon:SetPoint("TOPRIGHT", buff.barFrame, "TOPLEFT", 12, 0)
	
	if not buff.barFrame.statusBar then
		buff.barFrame.statusBar = CreateFrame("StatusBar", nil, buff.barFrame, "TextStatusBar")
	end
	buff.barFrame.statusBar:ClearAllPoints()
	buff.barFrame.statusBar:SetHeight(self.db.char.uptime.barHeight)
	buff.barFrame.statusBar:SetWidth(self.db.char.uptime.barWidth)
	buff.barFrame.statusBar:SetPoint("RIGHT", buff.barFrame, "RIGHT")
	buff.barFrame.statusBar:SetStatusBarTexture(media:Fetch("statusbar", self.db.char.texture))
	buff.barFrame.statusBar:SetStatusBarColor(buffColours.colourRed, buffColours.colourGreen, buffColours.colourBlue, buffColours.alpha)
	buff.barFrame.statusBar:SetMinMaxValues(0,1)
	buff.barFrame.statusBar:SetValue(0)
	
	local barfont = media:Fetch("font", self.db.char.barfont)
	if not buff.barFrame.statusBar.leftText then
		buff.barFrame.statusBar.leftText = buff.barFrame.statusBar:CreateFontString(nil, "OVERLAY")
	end
	buff.barFrame.statusBar.leftText:SetTextColor(1,1,1,1)
	buff.barFrame.statusBar.leftText:SetFont(barfont, self.db.char.barfontsize)
	buff.barFrame.statusBar.leftText:SetPoint("TOPLEFT", buff.barFrame.statusBar, "TOPLEFT")
	buff.barFrame.statusBar.leftText:SetText("0.0s")
	
	if not buff.barFrame.statusBar.rightText then
		buff.barFrame.statusBar.rightText = buff.barFrame.statusBar:CreateFontString(nil, "OVERLAY")
	end
	buff.barFrame.statusBar.rightText:SetTextColor(1,1,1,1)
	buff.barFrame.statusBar.rightText:SetFont(barfont, self.db.char.barfontsize)
	buff.barFrame.statusBar.rightText:SetPoint("TOPRIGHT", buff.barFrame.statusBar, "TOPRIGHT")
	buff.barFrame.statusBar.rightText:SetText("0%")
	
	buff.barFrame.statusBar:SetScript("OnEnter", function() UptimeStatusBarTooltip(buff) end);
	buff.barFrame.statusBar:SetScript("OnLeave", function() GameTooltip:Hide() end);
	buff.barFrame.buffIcon:SetScript("OnEnter", function() UptimeStatusBarTooltip(buff) end);
	buff.barFrame.buffIcon:SetScript("OnLeave", function() GameTooltip:Hide() end);
end

function UptimeStatusBarTooltip(buff)
	if not InCombatLockdown() then
		GameTooltip:SetOwner(buff.barFrame, "ANCHOR_BOTTOMLEFT");
		GameTooltip:AddLine(buff.name)
		GameTooltip:AddTexture(buff.icon)
		GameTooltip:AddLine((L["Uptime is %s (%s)"]):format(
				buff.barFrame.statusBar.leftText:GetText(),
				buff.barFrame.statusBar.rightText:GetText()
			))
		GameTooltip:Show()
	else
		GameTooltip:Hide()
	end
end

function ShockAndAwe:UpdateUptimeFrames(forceUpdate)
	if InCombatLockdown() or forceUpdate then
		local session = self.uptime.session
		local lastfight = self.uptime.lastfight
		session.buffs[Flurry].barFrame.statusBar.leftText:SetText(self:DurationString(session.buffs[Flurry].uptime))
		session.buffs[UnleashedRage].barFrame.statusBar.leftText:SetText(self:DurationString(session.buffs[UnleashedRage].uptime))
		session.buffs[ElementalDevastation].barFrame.statusBar.leftText:SetText(self:DurationString(session.buffs[ElementalDevastation].uptime))
		lastfight.buffs[Flurry].barFrame.statusBar.leftText:SetText(self:DurationString(lastfight.buffs[Flurry].uptime))
		lastfight.buffs[UnleashedRage].barFrame.statusBar.leftText:SetText(self:DurationString(lastfight.buffs[UnleashedRage].uptime))
		lastfight.buffs[ElementalDevastation].barFrame.statusBar.leftText:SetText(self:DurationString(lastfight.buffs[ElementalDevastation].uptime))

		local percent
		if session.totalTime == 0 then
			session.buffs[Flurry].barFrame.statusBar:SetValue(0)
			session.buffs[Flurry].barFrame.statusBar.rightText:SetText("0%")
			session.buffs[UnleashedRage].barFrame.statusBar:SetValue(0)
			session.buffs[UnleashedRage].barFrame.statusBar.rightText:SetText("0%")
			session.buffs[ElementalDevastation].barFrame.statusBar:SetValue(0)
			session.buffs[ElementalDevastation].barFrame.statusBar.rightText:SetText("0%")
		else
			percent = session.buffs[Flurry].uptime / session.totalTime
			session.buffs[Flurry].barFrame.statusBar:SetValue(percent)
			session.buffs[Flurry].barFrame.statusBar.rightText:SetText((("%d"):format(percent * 100)) .. "%")
		
			percent = session.buffs[UnleashedRage].uptime / session.totalTime
			session.buffs[UnleashedRage].barFrame.statusBar:SetValue(percent)
			session.buffs[UnleashedRage].barFrame.statusBar.rightText:SetText((("%d"):format(percent * 100)) .. "%")
		
			percent = session.buffs[ElementalDevastation].uptime / session.totalTime
			session.buffs[ElementalDevastation].barFrame.statusBar:SetValue(percent)
			session.buffs[ElementalDevastation].barFrame.statusBar.rightText:SetText((("%d"):format(percent * 100)) .. "%")
		end

		if lastfight.totalTime == 0 then
			lastfight.buffs[Flurry].barFrame.statusBar:SetValue(0)
			lastfight.buffs[Flurry].barFrame.statusBar.rightText:SetText("0%")
			lastfight.buffs[UnleashedRage].barFrame.statusBar:SetValue(0)
			lastfight.buffs[UnleashedRage].barFrame.statusBar.rightText:SetText("0%")
			lastfight.buffs[ElementalDevastation].barFrame.statusBar:SetValue(0)
			lastfight.buffs[ElementalDevastation].barFrame.statusBar.rightText:SetText("0%")
		else
			percent = lastfight.buffs[Flurry].uptime / lastfight.totalTime
			lastfight.buffs[Flurry].barFrame.statusBar:SetValue(percent)
			lastfight.buffs[Flurry].barFrame.statusBar.rightText:SetText((("%d"):format(percent * 100)) .. "%")
			
			percent = lastfight.buffs[UnleashedRage].uptime / lastfight.totalTime
			lastfight.buffs[UnleashedRage].barFrame.statusBar:SetValue(percent)
			lastfight.buffs[UnleashedRage].barFrame.statusBar.rightText:SetText((("%d"):format(percent * 100)) .. "%")

			percent = lastfight.buffs[ElementalDevastation].uptime / lastfight.totalTime
			lastfight.buffs[ElementalDevastation].barFrame.statusBar:SetValue(percent)
			lastfight.buffs[ElementalDevastation].barFrame.statusBar.rightText:SetText((("%d"):format(percent * 100)) .. "%")
		end
	end
end

function ShockAndAwe:ResetAllUptime()
	SAAUptimeFrame:ClearAllPoints()
	self.db.char.uptime.point = defaults.char.uptime.point
	self.db.char.uptime.relativeTo = defaults.char.uptime.relativeTo 
	self.db.char.uptime.relativePoint = defaults.char.uptime.relativePoint
	self.db.char.uptime.xOffset = defaults.char.uptime.xOffset
	self.db.char.uptime.yOffset = defaults.char.uptime.yOffset
	self.db.char.uptime.fWidth = defaults.char.uptime.fWidth
	self.db.char.uptime.fHeight = defaults.char.uptime.fHeight
	self.db.char.uptime.scale = defaults.char.uptime.scale
	SAAUptimeFrame:SetPoint(self.db.char.uptime.point, self.db.char.uptime.relativeTo, self.db.char.uptime.relativePoint, self.db.char.uptime.xOffset, self.db.char.uptime.yOffset)
	self:CreateUptimeFrame()
	self.db.char.barshow = true -- so that call to ShowHideBars resets to false
	self:ShowHideBars()
	self:Print(L["uptime_reset"])
end

---------------------------
-- Stats Frame functions
---------------------------

function ShockAndAwe:CreateStatsFrame()
	StatsFrame:SetScale(self.db.char.stats.scale)
	StatsFrame:SetFrameStrata("BACKGROUND")
	StatsFrame:SetWidth(self.db.char.stats.fWidth + self.db.char.stats.barHeight)
	StatsFrame:SetHeight(self.db.char.stats.fHeight)
	StatsFrame:SetBackdrop(frameBackdrop)
	StatsFrame:SetBackdropColor(0, 0, 0, self.db.char.stats.alpha);
	StatsFrame:SetMovable(true);
	StatsFrame:RegisterForDrag("LeftButton");
	StatsFrame:SetPoint(self.db.char.stats.point, self.db.char.stats.relativeTo, self.db.char.stats.relativePoint, self.db.char.stats.xOffset, self.db.char.stats.yOffset)
	StatsFrame:SetScript("OnDragStart", 
		function()
			StatsFrame:StartMoving();
		end );
	StatsFrame:SetScript("OnDragStop",
		function()
			StatsFrame:StopMovingOrSizing();
			StatsFrame:SetScript("OnUpdate", nil);
			self:FinishedMoving(true);
		end );
	
	if not StatsFrame.topText then
		StatsFrame.topText = StatsFrame:CreateFontString(nil, "OVERLAY")
	end
	StatsFrame.topText:SetTextColor(1,1,1,1)
	StatsFrame.topText:SetFont(media:Fetch("font", self.db.char.barfont), self.db.char.barfontsize)
	StatsFrame.topText:SetPoint("TOP", StatsFrame, "TOP")
	StatsFrame.topText:SetText(L["stats_session"])
	
	local baseOffset = (-1 * self.db.char.stats.fHeight / 8) -- 6 bars + top line + middle line 
	if not StatsFrame.middleText then
		StatsFrame.middleText = StatsFrame:CreateFontString(nil, "OVERLAY")
	end
	StatsFrame.middleText:SetTextColor(1,1,1,1)
	StatsFrame.middleText:SetFont(media:Fetch("font", self.db.char.barfont), self.db.char.barfontsize)
	StatsFrame.middleText:SetPoint("TOP", StatsFrame, "TOP", 0, 4 * baseOffset)
	StatsFrame.middleText:SetText(L["stats_lastfight"])
	if self.db.char.stats.show then
		StatsFrame:Show()
	else
		StatsFrame:Hide()
	end
end
